#ifndef _LOADER_HH_
#define _LOADER_HH_

#include "serial.hh"
extern "C" {
#include <stdio.h>
}

#include "gui.hh"
#include "option.hh"

class Loader {

  private:
	static const string bootString[];
	
	FILE *progStream;

	// these are ints instead of bools, because some underlying C
	// stuff gets confused (since bools are only 1 byte)
	int bulkErase;
	int bootstrapFeedback;
	int hardwareEcho;
	char* minEEPROM;
	char* fileName;

	bool wrotefffe;
	
	int decodeHex(const string str, int index);
	int hexToInt(char ch);
	bool loadRecord(int startAddr, int numBytes, char line_in[]);
	bool openProg();
	bool loadBoot();
	bool sync();
	bool loadProg();
	bool closeProg();
	
  public:

	//	OptionTable options;
	
	void checkPrereqs();
	Loader();

	void downloadFile();
};

#endif




