#include "config.h"
extern "C" {
    #include <libintl.h>
    #include <unistd.h>
}

#define MAIN
#include "config.h"

#include "globals.hh"
#include "option.hh"
#include "strings.hh"

int main(int argc, char **argv)
{
	poptContext pctx;
	
	bindtextdomain (PACKAGE, LOCALEDIR);
	textdomain (PACKAGE);
	
	// need to process Gui options here rather than in the constructor
	// like all my other classes, since the configuration has to be
	// read before I instantiate the Gui.
	char *commFontName = NULL;
	options.put(*(new Option(str.DEBUGLOPT, str.DEBUGSOPT, POPT_ARG_NONE, &debug, 0, str.DEBUGTIP, string(""))));
	options.put(*(new Option(str.COMMFNTLOPT, str.COMMFNTSOPT,  POPT_ARG_STRING, &commFontName, 0, str.COMMFNTTIP, string(""))));

	// merge in options from other classes
	//	options.merge(loader.options);
	//	options.merge(serial.options);
	options.read();
	
	gui = new Gui(argc, argv, options, &pctx);

	// >>>	poptFreeContext(pctx);

	//	loader.checkPrereqs();
	
	gui->run(gui->mainWin);
	
	return 0;
}


