#ifndef __OPTION_HH_
#define __OPTION_HH_

// I'm wrapping the poptOption code to avoid doing my own command line
// option parsing.  At this point, I'm not at all sure this is a good
// thing!

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include <vector>
using std::vector;
using std::string;

class Option {
	struct poptOption data;
	Gtk::Widget *widgetm;

  public:
	Option();
	Option(const Option& option);
	Option(const string& longName,
		   const string& shortName,
		   int argInfo,
		   void* arg,
		   int val,
		   const string& descrip,
		   const string& argDescrip);
	~Option();

	// accessors for metadata
	const char * longName() const;
	const char shortName();;
	int argInfo();
	const char *descrip();
	const char *argDescrip();
	Gtk::Widget *widget();

	// accessors for data
	bool getBool();
	char *getCStr();
	
	// mutators for metadata (only widget, and only because we have to
	// set up the option table before we set up the GUI.  Maybe
	// there's a way around that?
	void setWidget(Gtk::Widget *newWidget);

	// mutators for data
	void set(bool value);
	void set(char *value);
	void set(Glib::ustring value);
	  
};
					 
class OptionTable : public vector<Option> {
  private:
	static const int BUFSIZE = 256;
	ustring configfilename;
	FILE *etcfile, *dotfile;
	void readConfigurationFromFile(FILE *file);
	Option& search(const char shortName);

  public:
	void put(const Option& newoption);
	//	void merge(OptionTable& newoptions);

	Option& operator[](const char shortName);
	Option& operator[](const ustring& shortName);	
	
	OptionTable();
	
	void read(void);
	void write(void);
};
#endif

