//  $Log: serial.hh,v $
//  Revision 1.2  2000/08/03 03:58:31  pfeiffer
//  More changes than I even want to think about, upgrading to match
//  current gtk+ and gtkmm
//
//
//:  Serial port functions needed by the downloader
#ifndef _SERIAL_HH_
#define _SERIAL_HH_

#include "config.h"

extern "C" {
#include <termios.h>
}

#include <string>
#include <vector>

#include <sigc++/object.h>

#include "option.hh"
#include "strings.hh"

class Serial : public SigC::Object {
	int fd;

	void dumpAttrs(struct termios termios);
	
  public:
	//	OptionTable options;
	char *portName;
	int portnum;
	
	Serial();
	bool portIsOpen();
	bool openPort();
	bool closePort();
	bool initX(speed_t speed);
	bool init1200();
	bool init9600();

	int getFd() { return (fd); }
	int getChar();
	bool putChar(unsigned int c, bool echo);
	int getLastChar();
	void flush();
	bool drain();

	bool checkDev(const string& dirName, string& fileName); // check for accessible port with given name
};

#endif

