#ifndef _STRINGS_HH_
#define _STRINGS_HH_

#include <string>
using std::string;

#include "config.h"

// all strings used in the entire program should be in this class.
// The idea is that by defining them all in strings.cc, we can try to
// maintain some uniformity between the various labels and messages
// that the program will display.
class Str {
  public:
	// Program options strings
	const string BLKERASELOPT;
	const string BLKERASESOPT;
	const string BLKERASETIP;

	const string BTSTRPLOPT;
	const string BTSTRPSOPT;
	const string BTSTRPTIP;

	const string HDWRLOPT;
	const string HDWRSOPT;
	const string HDWRTIP;

	const string STRTLOPT;
	const string STRTSOPT;
	const string STRTTIP;
	
	const string MNEELOPT;
	const string MNEESOPT;
	const string MNEETIP;

	const string FILELOPT;
	const string FILESOPT;
	const string FILETIP;

	const string DEBUGLOPT;
	const string DEBUGSOPT;
	const string DEBUGTIP;

	const string PORTLOPT;
	const string PORTSOPT;
	const string PORTTIP;

	const string COMMFNTLOPT;
	const string COMMFNTSOPT;
	const string COMMFNTTIP;

	const string LABELFNTLOPT;
	const string LABELFNTSOPT;
	const string LABELFNTTIP;
	
	// Tooltips strings (except for tips derived from options)
	const string DOWNLOADTIP;
	const string COMMTIP;
	const string DWNLDTIP;
	const string QUITTIP;

	// Error strings
	const string NOERR;
	const string OKBUTERR;
	const string ADDRERR;
	
	const string CANTOPENERR;
	const string EMPTYERR;

	const string BADHEXERR;
	const string FMTERR;
	const string S23ERR;

    const string NOSERPORTS;
	const string PORTNOACCERR;

	const string CNTRDERR;
	const string CNTWRTERR;
	const string ECHOERR;
	const string SYNCERR;
	const string BULKSYNCERR;
	const string RESPERR;

	const string MEMERR;
	
	const string PORTNOSPECERR;
	const string BUFOVFLOWERR;
	const string BUFTOOSMALLERR;
	const string CLOSENULLERR;
	const string PROGCLOSEERR;
	const string NOTOPENERR;
	const string PORTCLOSEERR;
	const string GETATTRERR;
	const string ISPDERR;
	const string OSPDERR;
	const string SETATTRERR;
	const string SELERR;
	const string STATERR;
	const string NOGBOOLERR;
	const string NOGSTRNGERR;
	const string NOSBOOLERR;
	const string NOSSTRNGERR;
	const string NOSERDBGERR;
	
	// Debug messages
	const string SNDCHRDBG;
	const string GTCHRDBG;
	const string ATTRSDBG;
	const string PATTRSDBG;
	const string GETNOCHARDBG;
	const string PUTCHARDBG;
	const string OPENDIR1DBG;
	const string OPENDIR2DBG;
	const string XPND1DBG;
	const string XPND2DBG;
	const string CLSDIR1DBG;
	const string CLSDIR2DBG;
	const string CLPSDIR1DBG;
	const string CLPSDIR2DBG;
	const string CHCKFILDBG;
	const string DNLDPRESDBG;
	const string FLSTATDBG;
	const string STATDBG;
	const string SETIOTRUDBG;
	const string SETIOFLSDBG;
	const string TRYDEVDBG;
	const string BADNMDBG;
	const string SLNKNMDBG;
	const string OPENDBG;
	const string IOCTLDBG;
	const string NAMEDBG;
	const string PORTDBG;
	const string LINKDBG;
	const string RCDDBG;
	
	// labels (except those derived from options)
	const string LABELSLBL;
	const string COMMLBL;
	const string CNSTFONTLBL;
	const string DWNLDLBL;
	const string CNCLBL;
	const string DOWNTABLBL;
	const string COMMTABLBL;
	const string SETUPTABLBL;

	// menus
	const string EXITMENU;
	const string FILEMENU;
	const string HELPMENU;
	const string MANUALMENU;
	const string ABOUTMENU;

	// program status window
	const string IDLESTAT;
	const string BOOTSTAT;
	const string SYNCSTAT;
	const string BULKSTAT;
	const string EEPROMSTAT;
	const string NEEDPORTSTAT;
	const string NEEDFILESTAT;
	const string COMMSTAT;

	// ``about'' popup
	const string MYNAME;
	const string CAVEAT;
	const string LICENSE;
	
	Str();
};
#endif

